module testdynamic;
import clock;

struct TestObject
{
	VTable* vtable;
}

struct VTable
{
	void function(TestObject object)[1] vcall;
}

void vcallImplementation(TestObject object)
{
}

uint vcallOffset;

TestObject* createObject()
{
	TestObject* object = new TestObject;
	object.vtable = new VTable;
	object.vtable.vcall[0] = &vcallImplementation;
	vcallOffset = 0;
	return object;
}

uint testDynamic(uint testCount)
{
	TestObject* object = createObject;
	startClock;
	for (uint i; i < testCount; ++i)
		object.vtable.vcall[vcallOffset](*object);
	return currentClock;
}
